commit aaac798d29acb61ab510c6106d10fc641becfcb7
Author: Jakub Jelinek <jakub@redhat.com>
Date:   Mon Aug 10 17:53:46 2020 +0200

    c++: Fix constexpr evaluation of SPACESHIP_EXPR [PR96497]
    
    The following valid testcase is rejected, because cxx_eval_binary_expression
    is called on the SPACESHIP_EXPR with lval = true, as the address of the
    spaceship needs to be passed to a method call.
    After recursing on the operands and calling genericize_spaceship which turns
    it into a TARGET_EXPR with initialization, we call cxx_eval_constant_expression
    on it which succeeds, but then we fall through into code that will
    VERIFY_CONSTANT (r) which FAILs because it is an address of a variable.  Rather
    than avoiding that for lval = true and SPACESHIP_EXPR, the patch just tail
    calls cxx_eval_constant_expression - I believe that call should perform all
    the needed verifications.
    
    2020-08-10  Jakub Jelinek  <jakub@redhat.com>
    
            PR c++/96497
            * constexpr.c (cxx_eval_binary_expression): For SPACESHIP_EXPR, tail
            call cxx_eval_constant_expression after genericize_spaceship to avoid
            undesirable further VERIFY_CONSTANT.
    
            * g++.dg/cpp2a/spaceship-constexpr3.C: New test.
    
    (cherry picked from commit 5c64df80df274c753bfc8415bd902e1180e76f6a)

diff --git a/gcc/cp/constexpr.c b/gcc/cp/constexpr.c
index bda8d6a8bef..851c1a6114b 100644
--- a/gcc/cp/constexpr.c
+++ b/gcc/cp/constexpr.c
@@ -2983,8 +2983,8 @@ cxx_eval_binary_expression (const constexpr_ctx *ctx, tree t,
   else if (code == SPACESHIP_EXPR)
     {
       r = genericize_spaceship (type, lhs, rhs);
-      r = cxx_eval_constant_expression (ctx, r, lval, non_constant_p,
-					overflow_p);
+      return cxx_eval_constant_expression (ctx, r, lval, non_constant_p,
+					   overflow_p);
     }
 
   if (r == NULL_TREE)
diff --git a/gcc/testsuite/g++.dg/cpp2a/spaceship-constexpr3.C b/gcc/testsuite/g++.dg/cpp2a/spaceship-constexpr3.C
new file mode 100644
index 00000000000..95f03e6e231
--- /dev/null
+++ b/gcc/testsuite/g++.dg/cpp2a/spaceship-constexpr3.C
@@ -0,0 +1,7 @@
+// PR c++/96497
+// { dg-do compile { target c++20 } }
+
+#include <compare>
+
+static_assert(std::partial_ordering(std::strong_ordering::less) < 0);
+static_assert(std::partial_ordering(1 <=> 2) < 0);

